; BOM.LSP
; 11/4/91
; (c) 1991, Compass Int. Graphic Solutions 
; Author:  Terry Strominger
;
; Function Name:  (OUTLINE bn)
;
; Variables for function: (OUTLINE)
; bn       string         Block Name that contains attributes
;                         This is the name of the block being processed
; C_List   list           List containing column sizes
; cx       real           Current y-ins. value for row being worked on 
; hline    real           This sets the y value of the horizontal line
;                         that is placed under each line of attrib. text
;                         Increase this value to raise the line, decrease it
;                         to lower the line
; ori                     Original entity block when looping through SS1
; tspace   real           Text row spacing for rows (1.5 x text size)
; tsize    real           Text size to use
; X_List   list           X coords for Text
;
;======================================================================
(prompt "\n(OUTLINE)      Function to draw BOM outline")
(defun outline (bn / A_list SS1)
(setvar "CMDECHO" 0)
;
(setq 
     tsize (* 0.125 (getvar "DIMSCALE"))
     tspace (* 1.5 tsize)
     hline 6
)
;
(findatts bn);         build selection set w/all blocks "bn"
(if (not (null SS1))
(progn
(initget 1)
(setq p1 (getpoint "\nLocate upper right corner of chart:"))
(if (not (null p1))
 (progn
 ;
 ; now, assign column widths for columns
(if (= (strcase bn) "TEST")
(setq C_List (list 2.0 2.0 2.0 2.0))
(setq C_List (list (* 4.0 (GETVAR "DIMSCALE")) 
                   (* 3.25 (GETVAR "DIMSCALE")) 
                   (* 0.75 (GETVAR "DIMSCALE")) 
                   (* 2.25 (GETVAR "DIMSCALE"))
                   (* 0.75 (GETVAR "DIMSCALE"))))
)
;
;
; Establish X ins. pts. list (X_List)   for Attribute Text
; The X-Coord. will be 1/2 of the column width
;
(setq x2 0.0  
      X_List 
  (mapcar '(lambda (x1)
            (setq x (+ x2 (/ x1 2)) 
                  x2 (+ x2 x1)
                  x x)
           )
   C_List
  )
)
;
(setq p 0 cx (- (cadr p1) tspace) flag 1)
;
; now, loop through Sel. Set SS1 and process all attributes for 
; members in SS1.  This contains the blocks being processed
;
 (while (> (sslength SS1) 0)
   (setq a (ssname SS1 p) ori a cx (- cx tspace)
         XY_List nil A_List nil)
;
; Loop through all ATTRIBUTES of the block 'a'
(while (= (cdr (assoc 0 (entget (entnext a)))) "ATTRIB") 
;
; now, construct attribute list (A_List) for this block
;
   (setq a (entnext a)
         m (cdr (assoc 1 (entget a)))
         A_List (cons m A_List))
;
; The 1st time through this routine, the Attribute Tags are extracted
; and placed into the list Att_Tags
;
 (if (= flag 1) (setq Att_Tags (cons (cdr (assoc 2 (entget a))) Att_Tags))) 
;
; See if # of attributes match # of columns
;  
;
; attributes now in list A_List
; now, place into drawing
;
; First, construct X,Y pt insertion list for this block's attributes
; 
(setq XY_List (mapcar '(lambda (x)
       (list (- (car p1) x) cx (caddr p1))
       )
       X_List)
)
); end of while statement for attributes
;
;
; Call PRTEXT function to actually place attribs into BOM part of drawing
; 
 (mapcar 'prtext XY_List A_List)
;
; now, draw horizontal line that goes under the text currently
; being inserted into the BOM dwg.
; This is done by drawing a series of lines the same length as all of
; the column sizes in C_List
;
(prhline)
;(command "LINE" (list (car p1) (- cx (/ tspace hline)) (caddr p1))
;                (list (- (car p1) (apply '+ C_List))
;                      (- cx (/ tspace hline)) (caddr p1))
;         ""
;)
;
;
(setq SS1 (ssdel ori SS1))
(if (= flag 1) (setq flag 2))
);  end of while statement for ss sets
;
;
; All of the BLOCKS 'BN' have been processed, now need to draw rectangular
; border.
; *************** NOW, DRAW BORDER ****************** 
(setq cx (- cx (/ tspace hline)));  sets cx to y-min. value for btm of box
;
;
; draw outline rectangular border now
(setq l2 (list (- (car p1)
               (apply '+ C_List)) (cadr p1) (caddr p1))
      l3 (list (car l2) cx (caddr p1))
      l4 (list (car p1) cx (caddr p1))
)
(command "LINE" p1 l2 l3 l4 "c")
;
; now, draw vertical lines for each column in C_List
;
(setq XY_List nil a 0 m 0)
(repeat (- (length C_List) 1)
     (setq XY_List (cons
                    (+ m (nth a C_List))
                    XY_List
                   )
           m (+ m (nth a C_List)) 
           a (1+ a)
      )
)
(mapcar 'prvline XY_List)
;
; Now, insert attribute tags above box just drawn                      
(setq cx (- (cadr p1) tspace));  sets Y-ins pt for Att. Tags
;
; Now make XY Ins. Pt List for Attribute Tags
;
(setq XY_List (mapcar '(lambda (x)
       (list (- (car p1) x) cx (caddr p1))
       )
       X_List)
)
; now, place attribute tags into drawing
 (mapcar 'prtext XY_List Att_Tags)
;
; and then draw horizontal line under attribute tags
(prhline)
) 
); end of if, then progn for p1
); end of progn
(setq s (strcat "\nError -- No Blocks " bn " Found in Drawing"))
)
)
;
;
;
(prompt "\n(FINDATTS)     Function to find all blocks w/name: bn")
(defun findatts (bn)
(setq SS1 nil) (gc)
(setq SS1 (ssadd)
      SS1 (ssget "X" (list (cons 0 "INSERT") (cons 2 bn)))
      
)
; now, sort blocks and store sorted blocks in SS2
(if (not (null SS1))
   (progn
    (setq flag 0 p 0
          SS2 (ssadd))
    (while (> (sslength SS1) 0)
      (while (< p (sslength SS1)) 
        (setq e (ssname SS1 p)
              att (cdr (assoc 1 (entget (entnext e)))))
    ;
        (if (> flag 0);  if already past the 1st one in SS1
          (progn
            (if (< (atof att) sort)
                 (setq sort (atof att)
                       ent_SS2 e
                        p (1+ p)
                 )
            (setq p (1+ p))
            )
           )
        (setq flag 1 sort (atof att) ent_SS2 e p (1+ p))
        )
   ); end of second while statement
 ; now, add entity to SS2 and delete from SS1
    (setq SS1 (ssdel ent_SS2 SS1)
          SS2 (ssadd ent_SS2 SS2) 
            p 0 flag 0)
  )

(setq SS1 nil) (gc) (setq SS1 SS2)
)))
;
;
(prompt "\n(PRTEXT)    Function to place text into BOM list")
(defun prtext (x y)
  (command "text" "C" x tsize 0.0 y)
)
;
;
(prompt "\n(PRVLINE)     Function to draw vertical lines")
(defun prvline (x)
   (command "LINE" (list (- (car p1) x) (cadr p1) (caddr p1))
                   (list (- (car p1) x) cx (caddr p1))
              ""
    )
)
;
;
(prompt "\n(PRHLINE)      Function to draw horizontal line")
(defun prhline()
(command "LINE" (list (car p1) (- cx (/ tspace hline)) (caddr p1))
                (list (- (car p1) (apply '+ C_List))
                      (- cx (/ tspace hline)) (caddr p1))
         ""
)
)


